


/*

//;CD20060625
//CD2000312  specif ATA


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */
/*
/*      
JOURNAL
blocage CLK2 a zero lors de passage CMD (adresse 7):
Hard Court circuit entre CLK2 et INT du disque




*/


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */
/*

// interface IDE PIC

// pins

#define  PDIN 		PORTB,0   ; serial IN	74LS299 SHR	et serial IN 747LS164
#define  PDOUT		PORTB,0   ; serial OUT 	74LS299 QH
#define  CLK1		PORTB,0 	; clock		74LS299

#define  CLK2		PORTB,0 	; clock 74LS164

#define  PRD		PORTB,0 	; read  IDE
#define  PWR		PORTB,0 	; write IDE

#define  PINT		PORTB,0 	;interupt IDE


;A		SR/load et  
;B	33	DA1
;C	35	DA0
;D	37	CS0

;E	38	CS1
;F	36	DA2
;G
;H


; Commande Block Register CS0 
;Data		0
;Featur		1 (error)	
;SectorCount	2
;SectorNumber	3
;CylinderLow	4
;CylinderHigh	5
;Tete		6
;Command		7 (status en lecture)

;Adresse IDE symbolique lecture Commande Block Register CS0 
#define RCData 0xD1
#define RCFeat 0xD5
#define RCSCnt	0xD3
#define RCSNum 0xD7
#define RCCyLw 0xF1
#define RCCyLh 0xF5
#define RCTete 0xF3
#define RCCmmd 0xF7

; Control Block Register CS1
;DA2=0: not used
;DAx=6 read :alternate_status Write: device_control

alternate_status =status
7	6	5	4	3	2	1	0
BSY	DRDY	DF	DSC	DRQ	CORR	IDX	ERR




HE10 	nom		DB25		nom
1		clk2		2		D0
2		vcc
3		int
4		nc
5		din		3		D1
6		gnd		25
7		rd		4		D2
8		clk1		5		D3		
9		wr		6		D4
10		dout		10


*/


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */



#include <stdio.h>
#include <bios.h>
#include <fcntl.h>
#include <dos.h>

#include "IoCdP.H"

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */
/*

/******************** VARIABLE EN GLOBAL *********************/
/************** definition de l'envirronement ****************/

/***** Configuration carte /bit de controle du sens de transmission */

int PRND,CTRL,STATI;			/*Adresse courante de la carte selectionnee */
char D_PRND;


/*
//unsigned char CARTE_TYPE;        	/*1 adresse PRINTER 0 adresse DISPLAY, autre rien 
//unsigned char CARTE_BIT;         	/*Bit de direction 0....5 ou 255 si MONO DIR*/



/****************** SOUS PROGRAMME RELATIF A L'INTERFACE UART ************/
/****Adresse pour le port Display****/


/* #ifdef TurboC */
void Display()
{ PRND = 0x3BC; CTRL = 0x3BE; STATI = 0x3BD;};

void Printer()
{ PRND = 0x378; CTRL = 0x37A; STATI = 0x379;};

void Printer1()
{ PRND = 0x278; CTRL = 0x27A; STATI = 0x279;};

/*  #endif  */

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */



#ifdef WatCom
void outportb(char adresse, char data) { 
bios_printer(_PRINTER_WRITE,data,1);};
int inportb (char adresse) { return (bios_printer(_PRINTER_STATUS,0,1));};
#endif




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      
// IO de base */


#define CLK2 0x01
#define PDIN 0x02
#define PRD  0x04
#define CLK1 0x08
#define PWR  0x10

#define PDOUT 0x40


void bset (char PIN ) { D_PRND=D_PRND|PIN; 		outportb(PRND,D_PRND);}
void bclr (char PIN ) { D_PRND=D_PRND & ~PIN ; 	outportb(PRND,D_PRND);}

void G164 (char adresse);
void G299clk();
void G164Clk ();
int G299Read();
void G299OUT (int Data);

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */


void IDELectDatR( int Val)
	{int Nb;				/* lecture factice de M mot de data */
	G164 (RCData);			/* adresse OK +299 IN   */
	for (Nb=0;Nb<Val;Nb++) 	{bclr (PRD);bset(PRD);};				
	};


int IDEReady(int Timeout,int Mask,int Polarity)
	{int TimeMax;
	TimeMax=0;
	while ( (TimeMax<Timeout)&& ((IDELecture (RCCmmd)^Polarity) & Mask) ) TimeMax=TimeMax+1;
	if (TimeMax<Timeout) return(0); else return (1);
	};	


int IDEReadyCodIO(int Timeout,int Mask,int Polarity)
	{int TimeMax;
	TimeMax=0;
	while ((TimeMax<Timeout)&& ((IDELecture (RPIIrr)^Polarity) & Mask) ) TimeMax=TimeMax+1;
	if (TimeMax<Timeout) return(0); else return (1);
	};	





void IDEStPr()
{	char U; 	
	U=IDELecture (RCCmmd);	
	printf("Status:%x ",U);
	if (U&StBusy) printf("busy(D7) "); else printf("not busy(D7) "); 
	if (U&StRdy) printf("ready(D6) "); else printf("not ready(D6) "); 
	if (U&0x10) printf("Dsc(D4) "); else printf("not Dsc(D4) "); 
	if (U&StDrq) printf("DataReq(D3) \n"); else printf("not DataReq(D3)\n"); 
	if (U&0x04) printf("Corr(D2) "); else printf("not Corr(D2) "); 
	if (U&0x01) printf("Chk error(D0)\n "); else printf("not Chk error(D0)\n "); 
	if (U&0x01) printf("Error reg: %x ", IDELecture (RCFeat)&0xFF);
	printf(" \n");
	U=IDELecture (RPIIrr);	
	printf("Interupt reason register:%x \n",U);
	if (U&IrrCoD) printf("Attente commande\n "); else printf("Attente Data\n "); 
	if (U&IrrIO) printf("Data vers PC\n "); else printf("Data vers CDROM\n "); 
	
	};	


int IDELoop( int Val)
{	IDEInit ();
	IDEEcriture (RCCyLl, Val); /* test serial */
	return (G299Read());  /* lecture    */	
	
}	





void IDEInit ()
{	
/*	outportb(CTRL,0); 
	D_PRND=PRD|PWR|CLK1|CLK2; */

	bset (PRD);
	bset (PWR);
	G164Clk (); 
	G299clk();
	G164 (0xFF); 
	
	
}	


/* Lecture IDE */
int  IDELecture (char adresse)
	{char A,B,C;
	G164 (adresse);			/* adresse OK +299 IN   */
	

	/*A=D_PRND & ~PRD & ~CLK1;
	B=D_PRND |CLK1 & ~PRD ;
	C=D_PRND |PRD |CLK1;
	outportb(PRND,A);
	outportb(PRND,B);
	outportb(PRND,C); */

	bclr (PRD);
	bset (CLK1);
	bset (PRD); 

	
	bclr (CLK1);				/* chargement   */
	
	
	
	G164 (0xFE);				/* 299 SR   */
	return (G299Read());		/* lecture    */
	} 



void IDEEcriture (char adresse, int Data)
	{
	G164 (0xFE);				/*  SR   */
	G299OUT (Data);			/* charge   */
	G164 (adresse&0xFE);		/* adresse OK SR   */
	bclr (PWR);
	bset (PWR);
	}

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */



void G164 (char adresse)
	{char U;
	for (U=0;U<8;U++)
	{if (adresse& 0x80) bset (PDIN); else bclr (PDIN);
	adresse=adresse<<1;
	G164Clk ();		
	}
	
	}
	
void G299OUT (int data)
	{ int U,V;
	char T;
	U=0x0008; V=0x1000;
	for (T=0;T<4;T++)
	{
	if (data& U) bset (PDIN); else bclr (PDIN);
	G299clk();
	if (data& V) bset (PDIN); else bclr (PDIN);
	G299clk();
	U=U>>1; V=V<<1;
	}
	V=0x0080; U=0x0100;
	for (T=0;T<4;T++)
	{
	if (data& U) bset (PDIN); else bclr (PDIN);
	G299clk();
	if (data& V) bset (PDIN); else bclr (PDIN);
	G299clk();
	U=U<<1; V=V>>1;
	}
	
	}

void G164Clk ()
	{
	bset (CLK2);
	bclr (CLK2);
	}

void G299clk()
	{
	bset (CLK1);
	bclr (CLK1);
	}

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */



int G299Read()
	{char U,KL,KH,TL,TH;
	 int K;
	KL=0; KH=0; TL=0; TH=0; 
	
	
	for (U=0;U<4;U++)
	{KL=KL<<1;
	if ((inportb(STATI))& PDOUT) KL=KL|0x01;		/* D3.D2.D1.D0 */
	G299clk ();
	TH=TH>>1;	
	if (inportb(STATI)& PDOUT) TH=TH|0x08;		/* D12.D13.D14.D15 Attention 0x80:pbsigne*/
	G299clk ();	
	}
	for (U=0;U<4;U++)
	{TL=TL>>1;	
	if (inportb(STATI)& PDOUT) TL=TL|0x08;		/* D8.D9.D10.D11 */
	G299clk ();
	KH=KH<<1;
	if (inportb(STATI)& PDOUT) KH=KH|0x10;			/*  D7.D6.D5.D4 */
	G299clk ();	
	}
	TH=TH<<4; 
	K= (KL&0x0F) | (KH&0xF0) | ( ( (TL&0x0F) | (TH&0xF0))<<8);
	return(K);
	}


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/*      */
